//  _____         _  _____
// |_   _|____  _| ||_   _|_   __
//   | |/ _ \ \/ / __|| | \ \ / /
//   | |  __/>  <| |_ | |  \ V /
//   |_|\___/_/\_\\__||_|   \_/
// Author: Love Billenius <lovebillenius@disroot.org>
// License: GPL-3

#pragma once

#include <string>
#include <variant>


namespace Command {
    class NoNumberException final : public std::exception {
    public:
        [[nodiscard]] const char *what() const noexcept override {
            return "Seek option was used without a number";
        }
    };


    struct Help {
    };

    struct None {
    };

    struct Next {
    };

    struct Previous {
    };

    struct Refresh {
    };

    struct Exit {
    };

    struct Seek {
        int number;
    };

    using Command = std::variant<None, Help, Next, Previous, Refresh, Exit, Seek>;

    Command readCommand();
}
