//  _____         _  _____
// |_   _|____  _| ||_   _|_   __
//   | |/ _ \ \/ / __|| | \ \ / /
//   | |  __/>  <| |_ | |  \ V /
//   |_|\___/_/\_\\__||_|   \_/
// Author: Love Billenius <lovebillenius@disroot.org>
// License: GPL-3

#pragma once

#include <unordered_map>

#include "Page.hpp"


class Pager {
public:
    Pager() = default;

    Page &seek(int number);

    Pager &operator+=(int number);

    Pager &operator-=(int number);

    Page &operator*();
    Page *operator->();

    void set(int number);

    Page &get();

    void clear();

private:
    Page &get_page_at(int number);

private:
    std::unordered_map<int, Page> m_pages{};
    int m_page_number = 100;
};
